;
; run time parameters
;
DOS_START       EQU     1*1024*1024 ; this is where we will copy 512k base.

FLOPPER_START   EQU     512*1024/16 ; segment flopper loads just above 512k

REGS_START      EQU     DOS_START+(512*1024)  ; 1k of storage for regs+misc

DISK_START      EQU     REGS_START+(512*1024)+1024 ; storage for disk image
;
; standard diskette info
;
SECTOR_SIZE     EQU     512

SIZE160K        EQU     1*08*40*512      ; 1 sided, 8spt,  40 tracks
SIZE180K        EQU     1*09*40*512      ; 1 sided, 9spt,  40 tracks
SIZE200K        EQU     1*10*40*512      ; 1 sided, 10spt, 40 tracks
SIZE320K        EQU     2*08*40*512      ; 2 sided, 8spt,  40 tracks
SIZE360K        EQU     2*09*40*512      ; 2 sided, 9spt,  40 tracks
SIZE400K        EQU     2*10*40*512      ; 2 sided, 10spt, 40 tracks
SIZE720K        EQU     2*09*80*512      ; 2 sided, 9spt,  80 tracks
SIZE1200K       EQU     2*15*80*512      ; 2 sided, 15spt, 80 tracks
SIZE1440K       EQU     2*18*80*512      ; 2 sided, 18spt, 80 tracks

        ; diskette base error numbers

NO_DISK_ERROR           EQU     00h     ; a-ok status
DISK_WP_ERROR           EQU     03h     ; write protected diskette
SECTOR_NOT_FOUND_ERROR  EQU     04h     ; sector not found
DISK_CHANGED_ERROR      EQU     06h     ; diskette changed value


;
; flags and misc
;
DISK_CHANGE     EQU     BIT0            ; flag set for disk change
DISK_WRITTEN    EQU     BIT1            ; set if disk image changed
DISK_PROTECTED  EQU     BIT2            ; set if disk is write prot.
NOPIC           EQU     BIT4            ; set if we shouldn't reset the PIC
NOFLOPPY        EQU     BIT5            ; set if no floppy delay requested
REVECTORED      EQU     BIT6            ; flag set when INt 9 is revectored
SCREENSHOT      EQU     BIT7            ; flag for screenshot requested
F12_SCAN_CODE   EQU     58h             ; 58=F12  call up chooser

;
; command line flags
;
help		EQU	BIT0		; help requested
nocache		EQU	BIT1		; do not turn off L1 cache
nodelay		EQU	BIT2		; do not enable RTC delay
newdelay	EQU	BIT3		; new delay value supplied
newInterval	EQU	BIT4		; new RTC interval timer supplied
;
; video registers
;

CGA_CONTROL_REGISTER    EQU     03d8h




;
; assemble time parameters
;

DEBUG           EQU     0       ; turn on the debugger

RESETVECTORS    EQU     1       ; use "virgin" interrupt vector table.
                                ; this should only be disabled when debugging
F12             EQU     1       ; enable F12 chooser

SLOWCPU         EQU     0       ; slowdown CPU support code

DETECT_CPU      EQU     1       ; bail if CPU is not 386+
